#include "querycache.h"



resultcacheel::resultcacheel () 
{
  accessnum = -1;
}



querycache::querycache (int themaxcachesize)
{
  if (themaxcachesize < 1) themaxcachesize = 1;
  
  resultcache = new resultcacheel[themaxcachesize];

  maxcachesize = themaxcachesize;
  nextaccessnum = 1;
}

querycache::~querycache ()
{
  delete [] resultcache;
}

// returns true if the query was found in the cache
// if the query was found then queryresults contains
// the results
bool querycache::find (const queryparamclass &queryparams, 
		       queryresultsclass &queryresults)
{
  int i;

  for (i=0; i < maxcachesize; i++)
    {
      if (resultcache[i].queryparameters == queryparams)
	{
	  queryresults = resultcache[i].queryresults;
	  resultcache[i].accessnum = getnextaccessnum ();
	  return true;
	}
    }

  return false;
}


void querycache::cache (const queryparamclass &queryparams,
	  const queryresultsclass &queryresults)
{
  int i = getfreecachenum();
  resultcache[i].queryparameters = queryparams;
  resultcache[i].queryresults = queryresults;
  resultcache[i].accessnum = getnextaccessnum ();
}

int querycache::getnextaccessnum ()
{
  return nextaccessnum++;
}

int querycache::getfreecachenum ()
{
  int i;
  int minaccessnum = 0;
  int minaccessi = 0;
  
  for (i=0; i < maxcachesize; i++)
    {
      if (resultcache[i].accessnum < minaccessnum)
	minaccessi = i;
    }

  return i;
}

